/*
	Application Loto APSIO 

	Indiquez ci-dessous, en commentaire, les questions traites.
	
	( rappel : ne pas oublier de rajouter aussi un commentaire avant chaque
	squence ajoute ou modifie chaque fichier )
	
	Les numros des questions traites sont les suivants :
	   - question 1 : une mthode diffusion d'un message (chane) a t cre
	   - question 2 : la diffusion du rsultat du tirage se fait grce au
	   		canal de diffusion. Les num sont passs sous forme de chane puis
	   		reconvertis en entier
	   - question 3 : les messages sont transmis par le canal de diffusion
	   - question 4 : il faut interrompre le thread (serveur) par
	   		l'intermdiaire de la mthode wait() et le ractiver grce  la
	   		mthode notify() lorsque le nombre de tickets attendus est atteind
	
*/

import java.net.*;
import java.io.*;
import java.util.*;

class Serveur
{
	//final int nbClientsAttendus = 1;
	// question 1 : nombre de clients attendus fix  3
	final int nbClientsAttendus = 3;
	int nbClients = 0;
	// question 3 : indique le nombre de gagnants
	int nbGagnants = 0;

	Service serv=null;
	
	private Vector tickets = new Vector();
	// question 1 : cre un vector pour permettre une diffusion 
	// tous les services
	private Vector services = new Vector();

	public static void main( String[] args)
	{
		System.out.println("Serveur");
		new Serveur();
	}
	Serveur()
	{
		try
		{
			ServerSocket servSockCom = new ServerSocket( 5001);
			ServerSocket servSockDif = new ServerSocket( 5002);

			while( nbClients != nbClientsAttendus)
			{
				Socket sockCom = servSockCom.accept();
				System.out.println( "connexion du client numero "+(nbClients+1));
				Socket sockDif = servSockDif.accept();
				System.out.println( "connexion 5002 OK");
											
				serv = new Service( nbClients, sockCom, sockDif, this);
				serv.start();
				nbClients++;
				// question 1 : ajoute le nouveau service au vector et affiche
				// le numro du client
				services.add(serv);
				System.out.println(  " client num. : " + (nbClients-1) );

				Thread.sleep(3000);
				int reste = nbClientsAttendus - tickets.size();
				serv.envoiDif( reste + " ticket(s) attendu(s)" );
			}
			
			//while ( tickets.size() != nbClientsAttendus )
			//	Thread.sleep(1000);
			
			// question 4 : stop l'execution de ce thread jusqu' ce que le 
			// nombre de tickets attendus soit atteind
			synchronized(this)
			{
				wait();
			}
			Thread.sleep(2000);
			
			//serv.envoiDif( "< Tirage dans 10 secondes >" );
			// question 1 : diffuse un message  tous les clients au travers
			// des services
			diffuser("< Tirage dans 10 secondes >");
			Thread.sleep(5000);
			
			//serv.envoiDif( "<< Tirage dans 5 secondes >>" );
			// question 1
			diffuser("<< Tirage dans 5 secondes >>");
			Thread.sleep(3000);
			
			//serv.envoiDif( "<<< Tirage dans 2 secondes >>>" );
			// question 1
			diffuser("<<< Tirage dans 2 secondes >>>");
			
			Thread.sleep(2000);
			//serv.envoiDif( "<<<<<<  Tirage  >>>>>>" );
			// question 1
			diffuser("<<<<<<  Tirage  >>>>>>");
			Thread.sleep(1000);
			
			// simulation d'un tirage alatoire de 6 numros
			// on stocke le tirage dans un ticket attribu  un pseudo-joueur
			// dont le numro est 0
			Ticket tirage = new Ticket( 0, 12, 34, 5, 48, 20, 6);
			System.out.println( "tirage :" + tirage.toString() );
			
			// question 2 : diffusion du rsultat du tirage
			diffuser("tirage");
			for (int i=0; i < 6 ; i++)
			{
				// question 2 : diffuse le i-eme numro sous forme de chane
				diffuser(Integer.toString(tirage.getNumero(i)));
				// question 2 : attend 1s avant l'envoi du prochain numro
				Thread.sleep(1000);
			}
			
			// question 3 : compte le nombre de gagnants
			for (int i=0 ; i < tickets.size() ; i++)
			{
				if (tirage.equals((Ticket)tickets.elementAt(i)))
					nbGagnants++;
			}
			// question 3 : diffuse le nombre de gagnants
			diffuser("il y a " + nbGagnants + " gagnant(s)");
			// question 3 : fait patienter 3s
			Thread.sleep(3000);
			
			// question 3 : envoie  chaque client le nombre de bons numros
			// par le canale de diffusion
			for (int i=0 ; i < tickets.size() ; i++)
			{
				// Rcupre le ticket courant et le service du client concern
				Ticket ticket = (Ticket)tickets.elementAt(i);
				Service service = (Service)services.elementAt(ticket.getJoueur() - 1);
				int nbBonNum = tirage.nbBonsNumeros(ticket);
				// envoie un message selon le nombre de bons numros
				if (nbBonNum == 6)
				{
					service.envoiDif( "Bravo, vous avez gagn" );
				}
				else
				{
					service.envoiDif( "vous avez " + nbBonNum + " bon(s) numero(s)" );
				}
			}
			
			Thread.sleep(4000);
			System.out.println("Fin du serveur");
			//serv.envoiDif( "fin" );
			// question 1
			diffuser("fin");		
			Thread.sleep(1000);
		}
		catch (Exception e)
		{
			System.out.println("ERREUR"+e.getMessage());
			e.printStackTrace();
		}
	}

	void ajoutTicket( Ticket t) 
	{
		System.out.println("   ajout " + t.toString() );
		tickets.add( t);

		int reste = nbClientsAttendus - tickets.size();
		//serv.envoiDif( reste + " ticket(s) attendu(s)" );
		// question 1
		diffuser(reste + " ticket(s) attendu(s)");
		
		// question 4 : ractive le thread si le nombre de tickets attendus
		// est atteind
		if (reste == 0)
		{
			synchronized(this)
			{
				notify();
			}
		}
	}
	
	// question 1 : diffuse un message  tous les clients au travers
	// des services et du canal de diffusion
	private void diffuser(String s)
	{
		for (int i=0; i < services.size() ; i++)
		{
			Service service = (Service)services.elementAt(i);
			service.envoiDif( s );
		}
	}
}