import java.net.*;
import java.io.*;
import java.util.*;

class Ticket
{
	private int joueur;
	private int numeros[] = new int[6];
	private boolean ticketGagnant;
	public Ticket()
	{
		joueur = 0;
		ticketGagnant = false;
	}
	public Ticket(int j)
	{
		joueur = j;
		ticketGagnant = false;
	}
	public Ticket( int j, int n1, int n2, int n3, int n4, int n5, int n6)
	{
		joueur = j;
		numeros[0] = n1; numeros[1] = n2; numeros[2] = n3;
		numeros[3] = n4; numeros[4] = n5; numeros[5] = n6;
		ticketGagnant = false;
	}
	public void setNumero( int i, int num)
	{
		numeros[i] = num;
	}
	public int getNumero( int i )
	{
		return numeros[i];
	}
	public int getJoueur()
	{
		return joueur;
	}
	public boolean equals( Object o)
	{
		if ( ! o.getClass().getName().equals("Ticket"))
			return false;
		Ticket t = (Ticket)o;
		boolean ok = true;
		for (int i=0 ; i<6 && ok ; i++)
		{
			ok = false;
			for (int j=0 ; j<6 && ! ok ; j++)
				if ( t.getNumero(j) == numeros[i] )
					ok = true;
		}
		return ok;
	}
	public void setGagnant()
	{
		ticketGagnant = true;
	}
	public boolean isGagnant()
	{
		return ticketGagnant;
	}
	public int nbBonsNumeros( Ticket tirage)
	{
		int nb = 0; boolean ok;
		for (int i=0 ; i<6 ; i++)
		{
			ok = false;
			for (int j=0 ; j<6 && ! ok ; j++)
				if ( numeros[j] == tirage.getNumero(i) )
				{
					nb++; ok = true;
				}
		}
		return nb;
	}
	public String toString()
	{
		StringBuffer s = new StringBuffer( "joueur numero ");
		s.append( joueur);
		s.append( " :" );
		for (int i=0 ; i<6 ; i++)
			s.append( " " + numeros[i] );
		if ( ticketGagnant ) s.append( "GAGNANT");
		return s.toString();
	}
}
	